#!/usr/bin/env python
# -*- coding: utf-8 -*-

#   BatallaEspacial.py por:
#   Flavio Danesse <fdanesse@gmail.com>
#   Ceibal Jam - Uruguay - Plan Ceibal
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

import os, sys
import pygame
from pygame.locals import *

from NaveNodriza import NaveNodriza

pygame.init()
pygame.mouse.set_visible(False)
clock = pygame.time.Clock()
velocidad = 250

class BatallaEspacial():
# motor de juego

	def __init__(self):

		self.ventana = pygame.display.set_mode((1200, 900), pygame.RESIZABLE and pygame.DOUBLEBUF)

		imagen = pygame.image.load("/home/flavio/Escritorio/BatallaEspacial/Fondos/Fondo2.jpg").convert_alpha()
		rectangulodeimage = imagen.get_bounding_rect()
		self.fondo = imagen, rectangulodeimage

		self.minave = NaveNodriza()
		self.migrupo = pygame.sprite.Group()
		self.migrupo.add(self.minave)

		self.grupodecazas = self.minave.migrupo
		
		#self.x = 0
		while 1:
			pygame.event.pump()
		        keyinput = pygame.key.get_pressed()

		        if keyinput[K_ESCAPE] or pygame.event.peek(QUIT):
		        	sys.exit()

			if keyinput[K_1]:
				self.minave.formacion = "punta de lanza"
				print "punta de lanza"
			if keyinput[K_2]:
				self.minave.formacion = "muro"
				print "muro"

			if keyinput[K_z]:
				if self.minave.dist > 10:
					self.minave.dist -= 10

			if keyinput[K_a]:
				if self.minave.dist < 100:
					self.minave.dist += 10

		        self.handleMouse()

			segundos = clock.tick(25)/1000.0 # milisegundos / 1000.0
			distancia = segundos * velocidad

			self.actualizar()

	def handleMouse(self):
	# Escucha eventos del mouse
		left, middle, right = pygame.mouse.get_pressed()
		self.posiciondelmouse = pygame.mouse.get_pos()

		if left:
        		#player.fire([])
			try:
			# Probando eliminar naves
				self.minave.cazas[0].kill()
				del self.minave.cazas[0]
			except:
				print "no quedan naves"

	def actualizar (self):
	# actualiza las imágenes en cada ciclo del reloj
		self.ventana.blit(self.fondo[0], (0,0), self.fondo[1]) # Dibujar el fondo en la ventana

		for elemento in self.migrupo.sprites():
			elemento.actualizar(self.posiciondelmouse)
		self.migrupo.draw(self.ventana)
		self.grupodecazas.draw(self.ventana)
	
		pygame.display.update()

if __name__=="__main__":
   	juego = BatallaEspacial()
