#!/usr/bin/env python
# -*- coding: utf-8 -*-

#   BatallaEspacial.py por:
#   Flavio Danesse <fdanesse@gmail.com>
#   Ceibal Jam - Uruguay - Plan Ceibal
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

import os, sys
import pygame
from pygame.locals import *

from Caza import Caza

class NaveNodriza(pygame.sprite.Sprite):
# la nave principal que controla el usuario

	def __init__(self):

		pygame.sprite.Sprite.__init__(self)

		# Inicialización de variables
		self.dimensiones = (0,0)
		self.centro = (0,0)
		self.esquina_sup_izquierda = (0,0)
		self.esquina_sup_derecha = (0,0)
		self.esquina_inf_izquierda = (0,0)
		self.esquina_inf_derecha = (0,0)

		self.dist = 50 # Distancia entre cazas
		self.formacion = "punta de lanza"
		self.posiciondecazas = []
		

		self.image = pygame.image.load("/home/flavio/Escritorio/BatallaEspacial/Imagenes/minave2.png").convert_alpha()
		self.rect = self.image.get_bounding_rect()

		self.encontrarpuntosdelrectangulo()# Encuentra los puntos significativos
		self.posicionesdecazas() # Segun la formacion de batalla elegida, se definen las posiciones de los cazas

		# metiendo otros sprites en este
		self.cazas = []

		for posicion in self.posicionesen_formacion:
			self.cazas.append(Caza(posicion))

		self.migrupo = pygame.sprite.Group()
		self.migrupo.add(self.cazas)

	def posicionesdecazas(self):
	# Posiciones para naves cazas en nave nodriza segun formacion

		if self.formacion == "punta de lanza":
			self.posicionesen_formacion = []
			self.posicionesen_formacion.append((self.centro[0], self.centro[1] - self.dist*3))# 0
			self.posicionesen_formacion.append((self.centro[0] - self.dist, self.centro[1] - self.dist*2))# 1
			self.posicionesen_formacion.append((self.centro[0] + self.dist, self.centro[1] - self.dist*2))# 2
			self.posicionesen_formacion.append((self.centro[0] -self.dist*2, self.centro[1] - self.dist))# 3
			self.posicionesen_formacion.append((self.centro[0] +self.dist*2, self.centro[1] - self.dist))# 4
			self.posicionesen_formacion.append((self.centro[0] -self.dist*3, self.centro[1] - 0))# 5
			self.posicionesen_formacion.append((self.centro[0] +self.dist*3, self.centro[1] - 0))# 6
			self.posicionesen_formacion.append((self.centro[0] -self.dist*4, self.centro[1] + self.dist))# 7
			self.posicionesen_formacion.append((self.centro[0] +self.dist*4, self.centro[1] + self.dist))# 8
		if self.formacion == "muro":
			self.posicionesen_formacion = []
			self.posicionesen_formacion.append((self.centro[0], self.centro[1] - self.dist*3))# 0
			self.posicionesen_formacion.append((self.centro[0] - self.dist, self.centro[1] - self.dist*3))# 1
			self.posicionesen_formacion.append((self.centro[0] + self.dist, self.centro[1] - self.dist*3))# 2
			self.posicionesen_formacion.append((self.centro[0] -self.dist*2, self.centro[1] - self.dist*3))# 3
			self.posicionesen_formacion.append((self.centro[0] +self.dist*2, self.centro[1] - self.dist*3))# 4
			self.posicionesen_formacion.append((self.centro[0] -self.dist*3, self.centro[1] - self.dist*3))# 5
			self.posicionesen_formacion.append((self.centro[0] +self.dist*3, self.centro[1] - self.dist*3))# 6
			self.posicionesen_formacion.append((self.centro[0] -self.dist*4, self.centro[1] - self.dist*3))# 7
			self.posicionesen_formacion.append((self.centro[0] +self.dist*4, self.centro[1] - self.dist*3))# 8

	def actualizar(self, posiciondelmouse):
	# para actualizar lo que sea, en cada bucle del juego

		self.encontrarpuntosdelrectangulo()
		self.mover(posiciondelmouse)

		for caza in self.cazas:
			if caza.rect.left > caza.posicion[0] - caza.rect.width:
				caza.mover("izquierda")
						
			if caza.rect.left < caza.posicion[0]:
				caza.mover("derecha")

			if caza.rect.top < caza.posicion[1]:
				caza.mover("abajo")

			if caza.rect.top > caza.posicion[1] - caza.rect.height:
				caza.mover("arriba")

	def encontrarpuntosdelrectangulo(self):
	# obtiene todos los puntos relevantes de la imagen

		self.dimensiones = self.image.get_size()

		self.esquina_sup_izquierda = (self.rect.left, self.rect.top)# punto 0,0
		self.esquina_sup_derecha = (self.rect.left + self.rect.width, self.rect.top)# 0 + ancho de imagen, 0
		self.esquina_inf_izquierda = (self.rect.left, self.rect.top + self.rect.height)# 0, 0 + altura de la imagen
		self.esquina_inf_derecha = (self.rect.left + self.rect.width, self.rect.top + self.rect.height)# 0 + ancho de la imagen, 0 + altura de la imagen

		self.centro = self.rect.center

		try:
		# actualiza las posiciones de los cazas
			self.posicionesdecazas()
			self.cazas[0].posicion = self.posicionesen_formacion[0]
			self.cazas[1].posicion = self.posicionesen_formacion[1]
			self.cazas[2].posicion = self.posicionesen_formacion[2]
			self.cazas[3].posicion = self.posicionesen_formacion[3]
			self.cazas[4].posicion = self.posicionesen_formacion[4]
			self.cazas[5].posicion = self.posicionesen_formacion[5]
			self.cazas[6].posicion = self.posicionesen_formacion[6]
			self.cazas[7].posicion = self.posicionesen_formacion[7]
			self.cazas[8].posicion = self.posicionesen_formacion[8]

		except:
			pass

	def mover(self, posiciondelmouse):
	# mueve la nave. Como este movimiento se ve al ejecutar group.draw(superficie), en el motor del juego, lo que se hace en este
	# método es mover el rectángo del sprite ya que este es el que determina la posición sobre la superficie sobre la cual se dinujará
	# cuando se utiliza group.draw(superficie)

		pos_x, pos_y = self.rect.width/2 , self.rect.height/2
		mouse_x, mouse_y  = posiciondelmouse

		if self.rect.left + pos_x < mouse_x:
			self.rect = self.rect.move(20,0)

		if self.rect.left + pos_x  > mouse_x:
			self.rect = self.rect.move(-20,0)

		if self.rect.top  + pos_y < mouse_y:
			self.rect = self.rect.move(0,20)

		if self.rect.top  + pos_y > mouse_y:
			self.rect = self.rect.move(0,-20)
